#include <stdlib.h>

void init_intarr(int *arr, long int count, int value) {
  // function name: init_intarr
  // Initialize all elements of an array of integers to a single value

  long int i;
  for(i=0; i<count; i++)
    arr[i] = value;

} // end function init_intarr


void init_floatarr(float *arr, long int count, float value) {
  // function name: init_floatarr
  // Initialize all elements of an array of floats to a single value

  long int i;
  for(i=0; i<count; i++)
    arr[i] = value;

} // end function init_floatarr


void init_doublearr(double *arr, long int count, double value) {
  // function name: init_doublearr
  // Initialize all elements of an array of doubles to a single value

  long int i;
  for(i=0; i<count; i++)
    arr[i] = value;

} // end function init_doublearr


void freeNullDouble(double **x) {
  // function name: freeNullDouble
  
  // Free a pointer to type double and set to Null. This is considered
  // good practice since the freed pointer will not necessarily be set
  // to Null simply by calling free.

  if(*x)
    free(*x);
  *x = NULL;

} // end function freeNullDouble


void freeNullFloat(float **x) {
  // function name: freeNullFloat
  
  // Free a pointer to type float and set to Null. This is considered
  // good practice since the freed pointer will not necessarily be set
  // to Null simply by calling free.

  if(*x)
    free(*x);
  *x = NULL;

} // end function freeNullFloat


void freeNullInt(int **x) {
  // function name: freeNullInt
  
  // Free a pointer to type int and set to Null. This is considered
  // good practice since the freed pointer will not necessarily be set
  // to Null simply by calling free.

  if(*x)
    free(*x);
  *x = NULL;

} // end function freeNullInt


